diff --git a/build_patches/openwrt/0001-sysupgrade-no-config-save.patch b/build_patches/openwrt/0001-sysupgrade-no-config-save.patch
deleted file mode 100644
index 9cec414..0000000
--- a/build_patches/openwrt/0001-sysupgrade-no-config-save.patch
+++ /dev/null
@@ -1,25 +0,0 @@
-From 758b72379e994960ee1dcb0bf4f6db37140f59f0 Mon Sep 17 00:00:00 2001
-From: Tim Niemeyer <tim@tn-x.org>
-Date: Sat, 8 Jul 2017 10:46:59 +0200
-Subject: [PATCH 1/4] sysupgrade no config save
-
----
- package/base-files/files/sbin/sysupgrade | 2 +-
- 1 file changed, 1 insertion(+), 1 deletion(-)
-
-diff --git a/package/base-files/files/sbin/sysupgrade b/package/base-files/files/sbin/sysupgrade
-index bf5428a..e7d6f90 100755
---- a/package/base-files/files/sbin/sysupgrade
-+++ b/package/base-files/files/sbin/sysupgrade
-@@ -118,7 +118,7 @@ list_changed_conffiles() {
- add_uci_conffiles() {
- 	local file="$1"
- 	( find $(sed -ne '/^[[:space:]]*$/d; /^#/d; p' \
--		/etc/sysupgrade.conf /lib/upgrade/keep.d/* 2>/dev/null) \
-+		/etc/sysupgrade.conf 2>/dev/null) \
- 		-type f -o -type l 2>/dev/null;
- 	  list_changed_conffiles ) | sort -u > "$file"
- 	return 0
--- 
-2.7.4
-
diff --git a/src/packages/fff/fff-config/files/lib/upgrade/keep.d/fff-config b/src/packages/fff/fff-config/files/lib/upgrade/keep.d/fff-config
new file mode 100644
index 0000000..95c1329
--- /dev/null
+++ b/src/packages/fff/fff-config/files/lib/upgrade/keep.d/fff-config
@@ -0,0 +1 @@
+/etc/config/fff
diff --git a/src/packages/fff/fff-fastd/Makefile b/src/packages/fff/fff-fastd/Makefile
index b6ee5fb..4d48c7a 100644
--- a/src/packages/fff/fff-fastd/Makefile
+++ b/src/packages/fff/fff-fastd/Makefile
@@ -38,6 +38,10 @@ define Build/Compile
 	# nothing
 endef
 
+define Package/$(PKG_NAME)/install-overlay
+    $(CP) ./overlay/* $(1)/
+endef
+
 define Package/$(PKG_NAME)/install
 	$(CP) ./files/* $(1)/
 endef
diff --git a/src/packages/fff/fff-fastd/overlay/lib/upgrade/keep.d/fastd b/src/packages/fff/fff-fastd/overlay/lib/upgrade/keep.d/fastd
new file mode 100644
index 0000000..e69de29
diff --git a/src/packages/fff/fff-hoods/files/lib/upgrade/keep.d/fff-hoods b/src/packages/fff/fff-hoods/files/lib/upgrade/keep.d/fff-hoods
new file mode 100644
index 0000000..1b659ca
--- /dev/null
+++ b/src/packages/fff/fff-hoods/files/lib/upgrade/keep.d/fff-hoods
@@ -0,0 +1 @@
+/etc/hoodfile
diff --git a/src/packages/fff/fff-network/files/lib/upgrade/keep.d/fff-network b/src/packages/fff/fff-network/files/lib/upgrade/keep.d/fff-network
new file mode 100644
index 0000000..fa879f3
--- /dev/null
+++ b/src/packages/fff/fff-network/files/lib/upgrade/keep.d/fff-network
@@ -0,0 +1 @@
+/etc/network.config
diff --git a/src/packages/fff/fff-sysupgrade/Makefile b/src/packages/fff/fff-sysupgrade/Makefile
index 1ed3d46..383eabb 100644
--- a/src/packages/fff/fff-sysupgrade/Makefile
+++ b/src/packages/fff/fff-sysupgrade/Makefile
@@ -33,6 +33,10 @@ define Build/Compile
     # nothing
 endef
 
+define Package/$(PKG_NAME)/install-overlay
+    $(CP) ./overlay/* $(1)/
+endef
+
 define Package/$(PKG_NAME)/install
     $(CP) ./files/* $(1)/
 endef
diff --git a/src/packages/fff/fff-sysupgrade/files/etc/uci-defaults/99-fff-sysupgrade b/src/packages/fff/fff-sysupgrade/files/etc/uci-defaults/99-fff-sysupgrade
deleted file mode 100644
index 7ff83f5..0000000
--- a/src/packages/fff/fff-sysupgrade/files/etc/uci-defaults/99-fff-sysupgrade
+++ /dev/null
@@ -1,13 +0,0 @@
-#!/bin/sh
-# Copyright 2017 Tim Niemeyer
-# License GPLv3
-
-cat > /etc/sysupgrade.conf <<-__EOF__
-/etc/shadow
-/etc/dropbear/dropbear_dss_host_key
-/etc/dropbear/dropbear_rsa_host_key
-/etc/dropbear/authorized_keys
-/etc/network.config
-/etc/config/fff
-/etc/hoodfile
-__EOF__
diff --git a/src/packages/fff/fff-sysupgrade/files/lib/upgrade/keep.d/fff-sysupgrade b/src/packages/fff/fff-sysupgrade/files/lib/upgrade/keep.d/fff-sysupgrade
new file mode 100644
index 0000000..0a1b46b
--- /dev/null
+++ b/src/packages/fff/fff-sysupgrade/files/lib/upgrade/keep.d/fff-sysupgrade
@@ -0,0 +1,4 @@
+/etc/shadow
+/etc/dropbear/dropbear_dss_host_key
+/etc/dropbear/dropbear_rsa_host_key
+/etc/dropbear/authorized_keys
